"use strict";

var Service, Characteristic, HomebridgeAPI;

module.exports = function(homebridge) {

  Service = homebridge.hap.Service;
  Characteristic = homebridge.hap.Characteristic;
  HomebridgeAPI = homebridge;
  homebridge.registerAccessory("homebridge-ceiling-fan", "CeilingFan", CeilingFan);
}



function CeilingFan(log, config) {
  this.log = log;
  this.name = config.name;
  this.fanName= config["fan_name"] || this.name;
  this.fanState = false;
  this.log("Starting a fan  with name '" + this.fanName + "'...");

}
CeilingFan.prototype.getPowerOn = function(callback) {
  var powerOn = this.fanState > 0;
  this.log("Power state for the '%s' is %s", this.fanName, this.fanState);
  callback(null, powerOn);
}

CeilingFan.prototype.setPowerOn = function(powerOn, callback) {
  this.fanState = powerOn ? true : false; // wemo langauge
  this.log("Set power state on the '%s' to %s", this.fanName, this.fanState);
  callback(null);
}

CeilingFan.prototype.getServices = function() {
    var fanService = new Service.Fan(this.name);
    
    fanService
      .getCharacteristic(Characteristic.On)
      .on('get', this.getPowerOn.bind(this))
      .on('set', this.setPowerOn.bind(this));
    
    return [fanService];
}

